package com.bomostory.sceneeditmodule

import android.content.Context
import android.net.Uri
import android.os.Bundle
import android.support.v4.app.DialogFragment
import android.support.v4.app.Fragment
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.bomostory.sceneeditmodule.basicdata.Music
import com.bomostory.sceneeditmodule.utils.TimeUtils

import com.example.tfat.myapplication.R
import com.google.gson.Gson
import kotlinx.android.synthetic.main.fragment_music_edit_dialog.view.*

private const val ARG_PARAM1 = "editMusic"

/**
 * A simple [Fragment] subclass.
 * Activities that contain this fragment must implement the
 * [MusicEditDialog.OnFragmentInteractionListener] interface
 * to handle interaction events.
 * Use the [MusicEditDialog.newInstance] factory method to
 * create an instance of this fragment.
 *
 */
class MusicEditDialog : DialogFragment() {
    // TODO: Rename and change types of parameters
    private var editMusic: Music? = null
    private var listener: OnFragmentInteractionListener? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        arguments?.let {
            editMusic = Gson().fromJson(it.getString(ARG_PARAM1), Music::class.java)
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?,
                              savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.fragment_music_edit_dialog, container, false).apply {
            editMusic?.let {
                musicName.text = it.name
            }
        }
    }

    // TODO: Rename method, update argument and hook method into UI event
    fun onButtonPressed(uri: Uri) {
        listener?.onFragmentInteraction(uri)
    }

    override fun onAttach(context: Context) {
        super.onAttach(context)
        if (context is OnFragmentInteractionListener) {
            listener = context
        } else {
            throw RuntimeException(context.toString() + " must implement OnFragmentInteractionListener")
        }
    }

    override fun onDetach() {
        super.onDetach()
        listener = null
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     *
     *
     * See the Android Training lesson [Communicating with Other Fragments]
     * (http://developer.android.com/training/basics/fragments/communicating.html)
     * for more information.
     */
    interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        fun onFragmentInteraction(uri: Uri)
    }

    companion object {
        @JvmStatic
        fun newInstance(editMusic: String) =
                MusicEditDialog().apply {
                    arguments = Bundle().apply {
                        putString(ARG_PARAM1, editMusic)
                    }
                }
    }
}
